unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ShellApi, ShlObj, ActiveX, ComCtrls, ImgList, StdCtrls, ExtCtrls,
  ExtDlgs, 
  OrtusShellFormatDisk, OrtusShellDiskFull, OrtusShellExitWindows,
  OrtusShellRun, OrtusShellNewShortcut, OrtusShellControlPanel,
  OrtusShellBrowseFolder, OrtusShellBrowseComputer, OrtusShellAbout,
  OrtusShellOrganizeFavorites, OrtusShellProperties, OrtusShellOpenWith;

type
  TForm1 = class(TForm)
    OrtusShellControlPanel1: TOrtusShellControlPanel;
    OrtusShellOpenWith1: TOrtusShellOpenWith;
    OrtusShellNewShortcut1: TOrtusShellNewShortcut;
    OrtusShellRun1: TOrtusShellRun;
    OrtusShellExitWindows1: TOrtusShellExitWindows;
    OrtusShellDiskFull1: TOrtusShellDiskFull;
    OrtusShellFormatDisk1: TOrtusShellFormatDisk;
    OrtusShellProperties1: TOrtusShellProperties;
    OrtusShellOrganizeFavorites1: TOrtusShellOrganizeFavorites;
    OrtusShellAbout1: TOrtusShellAbout;
    OrtusShellBrowseComputer1: TOrtusShellBrowseComputer;
    OrtusShellBrowseFolder1: TOrtusShellBrowseFolder;
    ImageList1: TImageList;
    Panel1: TPanel;
    Button1: TButton;
    Panel2: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    TabSheet9: TTabSheet;
    TabSheet10: TTabSheet;
    TabSheet11: TTabSheet;
    TabSheet12: TTabSheet;
    Label1: TLabel;
    cbxControlPanelAplet: TComboBox;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    Label3: TLabel;
    Label4: TLabel;
    edtOpenWithFileName: TEdit;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    OpenDialog1: TOpenDialog;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    edtNewShortcutDestinationFolder: TEdit;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    Label17: TLabel;
    Label18: TLabel;
    edtRunCaption: TEdit;
    edtRunText: TEdit;
    Panel3: TPanel;
    ImgRunIcon: TImage;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    Label19: TLabel;
    cbxDiskFullDrive: TComboBox;
    SpeedButton10: TSpeedButton;
    Label20: TLabel;
    cbxFormatDiskDrive: TComboBox;
    SpeedButton11: TSpeedButton;
    OpenPictureDialog1: TOpenPictureDialog;
    Label21: TLabel;
    edtPropertiesFileName: TEdit;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    Label22: TLabel;
    edtAboutCaption: TEdit;
    Label23: TLabel;
    edtAboutShortText: TEdit;
    SpeedButton14: TSpeedButton;
    Label24: TLabel;
    edtAboutLongText: TEdit;
    SpeedButton15: TSpeedButton;
    Label25: TLabel;
    edtBrowseFolderInitialFolder: TEdit;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton18: TSpeedButton;
    lblBrowseComputerSelectedComputer: TLabel;
    lblBrowseFolderSelectedFolder: TLabel;
    Label26: TLabel;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton14Click(Sender: TObject);
    procedure SpeedButton15Click(Sender: TObject);
    procedure SpeedButton16Click(Sender: TObject);
    procedure SpeedButton17Click(Sender: TObject);
    procedure SpeedButton18Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
  private
    procedure FillDrives(Drives: TStrings; AllDrives: Boolean);
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FillDrives(Drives: TStrings; AllDrives: Boolean);
var
  Malloc: IMalloc;
  DesktopFolder: IShellFolder;
  DrivesFolder: IShellFolder;
  DrivesPIDL: PItemIDList;
  DrivePIDL: PItemIDList;
  DriveRootPath: string;
  EnumIDList: IEnumIDList;
  NumIDs: Cardinal;
  RelativePIDL: PItemIDList;
  DriveNum: Integer;

  function CreatePIDL(Size: Integer): PItemIDList;
  begin
    Result := Malloc.Alloc(Size);
    if Result <> nil then FillChar(Result^, Size, #0);
  end;

  function NextPIDL(PIDL: PItemIDList): PItemIDList;
  begin
    Result := PIDL;
    Inc(PChar(Result), PIDL^.mkid.cb);
  end;

  function GetPIDLSize(PIDL: PItemIDList): Integer;
  begin
    Result := 0;
    if PIDL <> nil then begin
      Result := SizeOf(PIDL^.mkid.cb);
      while PIDL^.mkid.cb <> 0 do begin
        Result := Result + PIDL^.mkid.cb;
        PIDL := NextPIDL(PIDL);
      end;
    end;
  end;

  function ConcatPIDLs(PIDL1, PIDL2: PItemIDList): PItemIDList;
  var
    cb1, cb2: Integer;
  begin
    if PIDL1 <> nil then cb1 := GetPIDLSize(PIDL1) - SizeOf(PIDL1^.mkid.cb) else cb1 := 0;
    cb2 := GetPIDLSize(PIDL2);
    Result := CreatePIDL(cb1 + cb2);
    if Assigned(Result) then begin
      if PIDL1 <> nil then CopyMemory(PChar(Result), PIDL1, cb1);
      CopyMemory(PChar(Result) + cb1, PIDL2, cb2);
    end;
  end;

  procedure FreePIDL(PIDL: PItemIDList);
  begin
    Malloc.Free(PIDL);
  end;

  function GetPIDLDisplayName(PIDL: PItemIDList): string;
  var
    Flags: Cardinal;
    FileInfo: TSHFileInfo;
  begin
    Flags := SHGFI_PIDL or SHGFI_DISPLAYNAME;
    SHGetFileInfo(PChar(PIDL), 0, FileInfo, SizeOf(FileInfo), Flags);
    Result := FileInfo.szDisplayName;
  end;

  function GetPIDLPath(PIDL: PItemIDList): string;
  var
    Buffer: array[0..MAX_PATH - 1] of Char;
  begin
    if SHGetPathFromIDList(PIDL, Buffer) then Result := Buffer else Result := '';
  end;

  function GetDescriptionID(ParentFolder: IShellFolder; RelativePIDL: PItemIDList): Cardinal;
  var
    SHDescriptionID: TSHDescriptionID;
  begin
    FillChar(SHDescriptionID, SizeOf(SHDescriptionID), 0);
    if SHGetDataFromIDList(
         ParentFolder,
         RelativePIDL,
         SHGDFIL_DESCRIPTIONID,
         @SHDescriptionID,
         SizeOf(SHDescriptionID)
       ) = S_OK then
      Result := SHDescriptionID.dwDescriptionId
    else
      Result := 0;
  end;

begin
  SHGetMalloc(Malloc);
  try
    SHGetDesktopFolder(DesktopFolder);
    try
      SHGetSpecialFolderLocation(0, CSIDL_DRIVES, DrivesPIDL);
      try
        DesktopFolder.BindToObject(DrivesPIDL, nil, IID_IShellFolder, Pointer(DrivesFolder));
        if DrivesFolder.EnumObjects(0, SHCONTF_NONFOLDERS, EnumIDList) <> S_OK then Exit;
        while EnumIDList.Next(1, RelativePIDL, NumIDs) = S_OK do begin
          try
            DrivePIDL := ConcatPIDLs(DrivesPIDL, RelativePIDL);
            try
              DriveRootPath := GetPIDLPath(DrivePIDL);
              if Length(DriveRootPath) = 0 then Continue;
              DriveNum := Ord(UpCase(DriveRootPath[1])) - Ord('A');
              if AllDrives or (GetDescriptionId(DrivesFolder, RelativePIDL) in [SHDID_COMPUTER_DRIVE35,
                   SHDID_COMPUTER_DRIVE525, SHDID_COMPUTER_REMOVABLE, SHDID_COMPUTER_RAMDISK]) then
                Drives.AddObject(GetPIDLDisplayName(DrivePIDL), Pointer(DriveNum));
            finally
              FreePIDL(DrivePIDL);
            end {try};
          finally
            FreePIDL(RelativePIDL);
          end {try};
        end;
      finally
        FreePIDL(DrivesPIDL);
      end {try};
    finally
      DesktopFolder := nil;
    end {try};
  finally
    Malloc := nil;
  end {try};
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  OrtusShellControlPanel1.CPL := TOrtusShellCPL(cbxControlPanelAplet.ItemIndex);
  OrtusShellControlPanel1.Execute;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    edtOpenWithFileName.Text := OpenDialog1.FileName;
    edtOpenWithFileName.SelectAll;
    ActiveControl := edtOpenWithFileName;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  PageControl1.ActivePage := TabSheet1;
  cbxControlPanelAplet.ItemIndex := 0;
  FillDrives(cbxDiskFullDrive.Items, True);
  if cbxDiskFullDrive.Items.Count > 0 then cbxDiskFullDrive.ItemIndex := 0;
  FillDrives(cbxFormatDiskDrive.Items, False);
  if cbxFormatDiskDrive.Items.Count > 0 then cbxFormatDiskDrive.ItemIndex := 0;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  OrtusShellOpenWith1.FileName := Trim(edtOpenWithFileName.Text);
  OrtusShellOpenWith1.Execute;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  OrtusShellNewShortcut1.DestinationFolder := Trim(edtNewShortcutDestinationFolder.Text);
  OrtusShellNewShortcut1.Execute;
end;

procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
  OrtusShellExitWindows1.Execute;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  OrtusShellRun1.Caption := Trim(edtRunCaption.Text);
  OrtusShellRun1.Text := Trim(edtRunText.Text);
  if not ImgRunIcon.Picture.Icon.Empty then
    OrtusShellRun1.Icon.Assign(ImgRunIcon.Picture.Icon);
  OrtusShellRun1.Execute;
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
  OrtusShellBrowseFolder1.InitialFolderName := Trim(edtNewShortcutDestinationFolder.Text);
  if OrtusShellBrowseFolder1.Execute then begin
    edtNewShortcutDestinationFolder.Text := OrtusShellBrowseFolder1.FolderName;
    edtNewShortcutDestinationFolder.SelectAll;
    ActiveControl := edtNewShortcutDestinationFolder;
  end;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then
    ImgRunIcon.Picture.Icon.LoadFromFile(OpenPictureDialog1.FileName);
end;

procedure TForm1.SpeedButton12Click(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    edtPropertiesFileName.Text := OpenDialog1.FileName;
    edtPropertiesFileName.SelectAll;
    ActiveControl := edtPropertiesFileName;
  end;
end;

procedure TForm1.SpeedButton13Click(Sender: TObject);
begin
  OrtusShellProperties1.FileName := Trim(edtPropertiesFileName.Text);
  OrtusShellProperties1.Execute;
end;

procedure TForm1.SpeedButton9Click(Sender: TObject);
begin
  OrtusShellOrganizeFavorites1.Execute;
end;

procedure TForm1.SpeedButton14Click(Sender: TObject);
begin
  OrtusShellAbout1.Caption := Trim(edtAboutCaption.Text);
  OrtusShellAbout1.ShortText := Trim(edtAboutShortText.Text);
  OrtusShellAbout1.LongText := Trim(edtAboutLongText.Text);
  OrtusShellAbout1.Execute;
end;

procedure TForm1.SpeedButton15Click(Sender: TObject);
begin
  if OrtusShellBrowseComputer1.Execute then
    lblBrowseComputerSelectedComputer.Caption := OrtusShellBrowseComputer1.ComputerName;
end;

procedure TForm1.SpeedButton16Click(Sender: TObject);
begin
  OrtusShellBrowseFolder1.InitialFolderName := Trim(edtBrowseFolderInitialFolder.Text);
  if OrtusShellBrowseFolder1.Execute then begin
    edtBrowseFolderInitialFolder.Text := OrtusShellBrowseFolder1.FolderName;
    edtBrowseFolderInitialFolder.SelectAll;
    ActiveControl := edtBrowseFolderInitialFolder;
  end;
end;

procedure TForm1.SpeedButton17Click(Sender: TObject);
begin
  OrtusShellBrowseFolder1.InitialFolderName := Trim(edtBrowseFolderInitialFolder.Text);
  if OrtusShellBrowseFolder1.Execute then
    lblBrowseFolderSelectedFolder.Caption := OrtusShellBrowseFolder1.FolderName;
end;

procedure TForm1.SpeedButton18Click(Sender: TObject);
begin
  ImgRunIcon.Picture.Icon := nil;
end;

procedure TForm1.SpeedButton10Click(Sender: TObject);
begin
  if cbxDiskFullDrive.ItemIndex = -1 then Exit;
  OrtusShellDiskFull1.Drive := Char(Ord('A') + Integer(cbxDiskFullDrive.Items.Objects[cbxDiskFullDrive.ItemIndex]));
  OrtusShellDiskFull1.Execute;
end;

procedure TForm1.SpeedButton11Click(Sender: TObject);
begin
  if cbxFormatDiskDrive.ItemIndex = -1 then Exit;
  OrtusShellFormatDisk1.Drive := Char(Ord('A') + Integer(cbxFormatDiskDrive.Items.Objects[cbxFormatDiskDrive.ItemIndex]));
  OrtusShellFormatDisk1.Execute;
end;

end.
